#include "die.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>

int main() {
    char *url = "www.fau.de";
    char *port = "80";
    struct addrinfo hints =
        {
        .ai_socktype = SOCK_STREAM,   // Nur TCP-Sockets
        .ai_family   = AF_UNSPEC,     // Beliebige Adressfamilie
        .ai_flags    = AI_ADDRCONFIG, // Nur Adresstypen für die auch ein lokales Interface existiert
        }; // C: alle anderen Elemente der Struktur werden implizit genullt
    
    struct addrinfo *head;
    int res = getaddrinfo(url, port, &hints, &head);
    if(res) die_m(gai_strerror(res));
    
    // Liste der Adressen durchtesten
    int sock;
    struct addrinfo *curr;
    for (curr = head; curr != NULL; curr = curr->ai_next) {
        sock = socket(curr->ai_family, curr->ai_socktype, curr->ai_protocol);
        if(sock == -1) {// Fehlerbehandlung
        continue;
        }
        if (connect(sock, curr->ai_addr, curr->ai_addrlen) == 0) break;
        close(sock);
    }
    freeaddrinfo(head);
    if (curr == NULL) die_m("Could not connect to server");

    FILE *rx, *tx;
    if( (rx = fdopen(sock, "r")) == NULL) die("fdopen");
    int sock_copy = dup(sock);
    if(sock_copy < 0) die("dup");
    if( (tx = fdopen(sock_copy, "w")) == NULL ) die("fdopen");

    //test it
    fprintf(tx, "GET http://www.fau.de/index.html HTTP/1.1\r\n\r\n");
    fflush(tx);
    char *lineptr = NULL;
    size_t lineSize = 0;
    ssize_t strLen = 0;
    strLen = getline(&lineptr, &lineSize, rx);
    if(strLen < 0) {
        if(ferror(rx)) die("getline");
    }
    printf("%s\n", lineptr);
    free(lineptr);
    
    if(fclose(rx)) perror("fclose");
    if(fclose(tx)) perror("fclose");
}
