#include "die.h"
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <string.h>

#define BASEDIR "."

static int filter(const struct dirent *dir) {
    if(dir->d_name[0] == '.') {
        return 0;//filter out .files
    }
    struct stat st;
    char name[strlen(BASEDIR) + strlen(dir->d_name) + 2];
    sprintf(name, "%s/%s", BASEDIR, dir->d_name);
    if(stat(name, &st) == -1) die("stat");//lstat don't folow symlinks
    if(S_ISREG(st.st_mode)) {
        return 1;
    }
    return 0;
}

/** list files
 */
static void listDir(){
    struct dirent **namelist; //array of dirents
    int n = scandir(BASEDIR, &namelist, filter, alphasort);//filter oder NULL
    if (n == -1) {
        die("scandir");
    }

    while (n--) {
        printf("%s/%s\n", BASEDIR, namelist[n]->d_name);
        free(namelist[n]);
    }
    free(namelist);
}

int main() {
    listDir();
}
