#include <stdio.h>
#include <stdlib.h>

#define DIE(msg) \
    fprintf(stderr, "ERROR: %s:%s:%d: ", __FILE__, __func__, __LINE__); \
    perror(msg); \
    exit(EXIT_FAILURE);

#define DIE_M(msg) \
    fprintf(stderr, "ERROR: %s:%s:%d: ", __FILE__, __func__, __LINE__); \
    fprintf(stderr, "%s\n", msg); \
    exit(EXIT_FAILURE);

#ifdef DEV

#define WARN(msg) \
    fprintf(stderr, "WARN: %s:%s:%d: ", __FILE__, __func__, __LINE__); \
    perror(msg);

#define WARN_M(msg) \
    fprintf(stderr, "WARN: %s:%s:%d: ", __FILE__, __func__, __LINE__); \
    fprintf(stderr, "%s\n", msg);


/** debug info + perror goes to stderr to seperate from program output */
#define INFO(msg) \
    fprintf(stderr, "INFO: %s:%s:%d: ", __FILE__, __func__, __LINE__); \
    perror(msg);

/** debug info goes to stderr to seperate from program output */
#define INFO_M(msg) \
    fprintf(stderr, "INFO: %s:%s:%d: ", __FILE__, __func__, __LINE__); \
    fprintf(stderr, "%s\n", msg);
#else
#define WARN(msg)
#define WARN_M(msg)
#define INFO(msg)
#define INFO_M(msg)
#endif

int main() {
    INFO("inf");
    DIE_M("test");
}