#include <errno.h>
#include <stdlib.h>
/**
 * @brief strtoul with error checks
 * 
 * @param str String to be parsed
 * @param num return param where the unsigned long gets written to (gets only changed on success)
 * @return 0 on success, none zero on error
 */
static int strtoulSave(const char *str, unsigned long *num) {
    char *endptr;
    int eno = errno;
    errno = 0;
    unsigned long value = strtoul(str, &endptr, 10);
    if(errno) return errno;
    errno = eno; // restore errno, so we're not unintentionally loosing errors when calling this function

    if (endptr == str) return EINVAL; // no digits found
    if(*endptr != '\0') return EINVAL; // contains invalid character

    *num = value;
    return 0;
}

int main(){
    unsigned long num;
    strtoulSave("123", &num);
}
