#include "die.h"
#include <errno.h>
#include <pthread.h>
#include "jbuffer.h"

#define POISON 123456
#define BUFSIZE 32
#define THREADS 8

static BNDBUF *jbuf;

static void *workerMain(void *param){
    for(int val = bbGet(jbuf); val != POISON; val = bbGet(jbuf)) {
        //handle val
        printf("%d\n", val);
    }
    return param;
}

int main() {
    // init jbuf
    jbuf = bbCreate(BUFSIZE);
    if (jbuf == NULL) die_m("failed to create jbuffer");

    // create threads
    pthread_t tids[THREADS];
    for (int i = 0; i < THREADS; i++) {
        //pthread_t thread;
        if ( (errno = pthread_create(&tids[i], NULL, workerMain, NULL)) != 0 ) die("pthread_create");
        //if ( (errno = pthread_detach(thread)) != 0 ) die("pthread_detach");
    }

    //put work (z.B. clientSock) in the queue
    bbPut(jbuf, 123);

    //kill them all
    for (int i = 0; i < THREADS; i++) {
        bbPut(jbuf, POISON);
    }
    for (int i = 0; i < THREADS; i++) {
        errno = pthread_join(tids[i], NULL);//void **retval
	    if (errno != 0) perror("pthread_join()");
    }
}
